abstract class Produto {
      protected int codigo;
      protected String descricao;
      abstract public String getFullDescription();
      public Produto( int cod, String desc) {
	  codigo = cod;
	  descricao = desc;
      }
}
class Livro extends Produto {
      private String autor;
      public Livro(int cod, String desc, String aut) {
	  super(cod,desc);
	  autor = aut;
      }
      public String getFullDescription() {
	    return "Livro: "+codigo+" "+descricao+ " " + autor;
      }
}
class Relogio extends Produto {
      private String marca;
      public Relogio(int cod, String desc, String mar) {
	  super(cod,desc);
	  marca = mar;
      }
      public String getFullDescription() {
	    return "Relogio: "+codigo+" "+descricao+ " " + marca;
      }
}

public class exemploheranca {
      public static void main (String args[]) {
	    Produto p;
	    Relogio rel = new Relogio(1, "Pulso", "Casio");
	    Livro liv = new Livro(2, "Java", "Barnes");
	    p = rel;
	    System.out.println(p.getFullDescription());
	    p = liv;
	    System.out.println(p.getFullDescription());

	    /*if (p instanceof Relogio) {
		Relogio novorel = (Livro)p;
		System.out.println(novorel.getFullDescription());
	    }
	    p = liv;
	    if (p instanceof Livro) {
		Livro novoliv = (Livro)p;
		System.out.println(novoliv.getFullDescription());
	    }*/
	    
      }
}